using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class BallBehaviour : MonoBehaviour
{
    private Rigidbody rb;
    private AudioSource aSource;

    public AudioClip sndJump, sndHit, sndSuccess, sndFail;    

    // Start is called before the first frame update
    void Start()
    {
        // Debug.Log("Start");
        rb = GetComponent<Rigidbody>();
        aSource = GetComponent<AudioSource>();
    }

    // Update is called once per frame
    void Update()
    {
        // Debug.Log("Update");        
        //Vector3 vTmp = new Vector3(Input.GetAxis("Horizontal"), 0, Input.GetAxis("Vertical")) * Time.deltaTime * 1000.0f;
        //rb.AddForce(vTmp);
        if (Input.GetButtonDown("Jump") && rb.velocity.y == 0)
        {
            rb.AddForce(Vector3.up * 250.0f);
            aSource.PlayOneShot(sndJump);
        }

        if (transform.localPosition.y < -10.0f)
        {
            Debug.Log("Game over");
            aSource.PlayOneShot(sndFail);
            enabled = false;
            Invoke("Restart",5);
        }
    }

    void Restart()
    {
        Debug.Log("Restart");
        SceneManager.LoadScene(0);
    }

    void FixedUpdate()
    {
        Vector3 vTmp = new Vector3(Input.GetAxis("Horizontal"), 0, Input.GetAxis("Vertical"))*10.0f;
        rb.AddForce(vTmp);
    }

    void OnTriggerEnter(Collider c)
    {
        if (c.CompareTag("Finish"))
        {
            Debug.Log("Finish");
            aSource.PlayOneShot(sndSuccess);
            enabled = false;
            Invoke("Restart",5);
        }

        if (c.CompareTag("Pickup"))
        {
            Debug.Log("Pickup");
            Destroy(c.transform.parent.gameObject);
            UIBehaviour.instance.Points += 10;
            //UIBehaviour.instance.Points = UIBehaviour.instance.Points + 10;
        }
    }

    void OnCollisionEnter(Collision c)
    {
        if (c.collider.CompareTag("Wall"))
        {
            Debug.Log("wall");
            aSource.volume = rb.velocity.magnitude;
            aSource.pitch = Random.Range(0.9f,1.1f);
            aSource.PlayOneShot(sndHit);
        }
    }
}
